OGRE: Ogre::v1::Pose Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | List of all members
Ogre::v1::Pose Class Reference
Core » Animation

A pose is a linked set of vertex offsets applying to one set of vertex data. More...

`#include <OgrePose.h>`

Inheritance diagram for Ogre::v1::Pose:
[legend]

## Public Types
typedef ConstMapIterator< NormalsMap > | ConstNormalsIterator
| An iterator over the vertex offsets. More...
typedef ConstMapIterator< VertexOffsetMap > | ConstVertexOffsetIterator
| An iterator over the vertex offsets. More...
typedef MapIterator< NormalsMap > | NormalsIterator
| An iterator over the vertex offsets. More...
typedef map< size_t, Vector3 >::type | NormalsMap
| A collection of normals based on the vertex index. More...
typedef MapIterator< VertexOffsetMap > | VertexOffsetIterator
| An iterator over the vertex offsets. More...
typedef map< size_t, Vector3 >::type | VertexOffsetMap
| A collection of vertex offsets based on the vertex index. More...

## Public Member Functions
| Pose (ushort target, const String &name=BLANKSTRING)
| Constructor. More...
virtual | ~Pose ()
const HardwareVertexBufferSharedPtr & | _getHardwareVertexBuffer (const VertexData *origData) const
| Get a hardware vertex buffer version of the vertex offsets. More...
void | addVertex (size_t index, const Vector3 &offset)
| Adds an offset to a vertex for this pose. More...
void | addVertex (size_t index, const Vector3 &offset, const Vector3 &normal)
| Adds an offset to a vertex and a new normal for this pose. More...
void | clearVertices (void)
| Clear all vertices. More...
Pose * | clone (void) const
| Clone this pose and create another one configured exactly the same way (only really useful for cloning holders of this class). More...
bool | getIncludesNormals () const
| Return whether the pose vertices include normals. More...
const String & | getName (void) const
| Return the name of the pose (may be blank) More...
const NormalsMap & | getNormals (void) const
| Gets a const reference to the vertex offsets. More...
NormalsIterator | getNormalsIterator (void)
| Gets an iterator over all the vertex offsets. More...
ConstNormalsIterator | getNormalsIterator (void) const
| Gets an iterator over all the vertex offsets. More...
ushort | getTarget (void) const
| Return the target geometry index of the pose. More...
VertexOffsetIterator | getVertexOffsetIterator (void)
| Gets an iterator over all the vertex offsets. More...
ConstVertexOffsetIterator | getVertexOffsetIterator (void) const
| Gets an iterator over all the vertex offsets. More...
const VertexOffsetMap & | getVertexOffsets (void) const
| Gets a const reference to the vertex offsets. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
void | removeVertex (size_t index)
| Remove a vertex offset. More...

## Detailed Description

A pose is a linked set of vertex offsets applying to one set of vertex data.

Remarks
  The target index referred to by the pose has a meaning set by the user of this class; but for example when used by Mesh it refers to either the Mesh shared geometry (0) or a SubMesh dedicated geometry (1+). Pose instances can be referred to by keyframes in VertexAnimationTrack in order to animate based on blending poses together.

## Member Typedef Documentation

## ◆ ConstNormalsIterator

typedef ConstMapIterator<NormalsMap> Ogre::v1::Pose::ConstNormalsIterator

An iterator over the vertex offsets.

## ◆ ConstVertexOffsetIterator

typedef ConstMapIterator<VertexOffsetMap> Ogre::v1::Pose::ConstVertexOffsetIterator

An iterator over the vertex offsets.

## ◆ NormalsIterator

typedef MapIterator<NormalsMap> Ogre::v1::Pose::NormalsIterator

An iterator over the vertex offsets.

## ◆ NormalsMap

typedef map<size_t, Vector3>::type Ogre::v1::Pose::NormalsMap

A collection of normals based on the vertex index.

## ◆ VertexOffsetIterator

typedef MapIterator<VertexOffsetMap> Ogre::v1::Pose::VertexOffsetIterator

An iterator over the vertex offsets.

## ◆ VertexOffsetMap

typedef map<size_t, Vector3>::type Ogre::v1::Pose::VertexOffsetMap

A collection of vertex offsets based on the vertex index.

## Constructor & Destructor Documentation

## ◆ Pose()

Ogre::v1::Pose::Pose | ( | ushort | target,
|  | const String & | name = `BLANKSTRING`
| ) |  |

Constructor.

Parameters

  target | The target vertexdata index (0 for shared, 1+ for dedicated at the submesh index + 1)
  name | Optional name

## ◆ ~Pose()

virtual Ogre::v1::Pose::~Pose | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ _getHardwareVertexBuffer()

const HardwareVertexBufferSharedPtr& Ogre::v1::Pose::_getHardwareVertexBuffer | ( | const VertexData * | origData | ) | const

Get a hardware vertex buffer version of the vertex offsets.

## ◆ addVertex() [1/2]

void Ogre::v1::Pose::addVertex | ( | size_t | index,
|  | const Vector3 & | offset
| ) |  |

Adds an offset to a vertex for this pose.

Parameters

  index | The vertex index
  offset | The position offset for this pose

## ◆ addVertex() [2/2]

void Ogre::v1::Pose::addVertex | ( | size_t | index,
|  | const Vector3 & | offset,
|  | const Vector3 & | normal
| ) |  |

Adds an offset to a vertex and a new normal for this pose.

Parameters

  index | The vertex index
  offset | The position offset for this pose

## ◆ clearVertices()

void Ogre::v1::Pose::clearVertices | ( | void |  | ) |

Clear all vertices.

## ◆ clone()

Pose* Ogre::v1::Pose::clone | ( | void |  | ) | const

Clone this pose and create another one configured exactly the same way (only really useful for cloning holders of this class).

## ◆ getIncludesNormals()

bool Ogre::v1::Pose::getIncludesNormals | ( |  | ) | const
| inline

Return whether the pose vertices include normals.

## ◆ getName()

const String& Ogre::v1::Pose::getName | ( | void |  | ) | const
| inline

Return the name of the pose (may be blank)

## ◆ getNormals()

const NormalsMap& Ogre::v1::Pose::getNormals | ( | void |  | ) | const
| inline

Gets a const reference to the vertex offsets.

## ◆ getNormalsIterator() [1/2]

NormalsIterator Ogre::v1::Pose::getNormalsIterator | ( | void |  | ) |

Gets an iterator over all the vertex offsets.

## ◆ getNormalsIterator() [2/2]

ConstNormalsIterator Ogre::v1::Pose::getNormalsIterator | ( | void |  | ) | const

Gets an iterator over all the vertex offsets.

## ◆ getTarget()

ushort Ogre::v1::Pose::getTarget | ( | void |  | ) | const
| inline

Return the target geometry index of the pose.

Referenced by Ogre::Lod0Stripifier::StripLod0Vertices().

## ◆ getVertexOffsetIterator() [1/2]

VertexOffsetIterator Ogre::v1::Pose::getVertexOffsetIterator | ( | void |  | ) |

Gets an iterator over all the vertex offsets.

## ◆ getVertexOffsetIterator() [2/2]

ConstVertexOffsetIterator Ogre::v1::Pose::getVertexOffsetIterator | ( | void |  | ) | const

Gets an iterator over all the vertex offsets.

## ◆ getVertexOffsets()

const VertexOffsetMap& Ogre::v1::Pose::getVertexOffsets | ( | void |  | ) | const
| inline

Gets a const reference to the vertex offsets.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ removeVertex()

void Ogre::v1::Pose::removeVertex | ( | size_t | index | ) |

Remove a vertex offset.

The documentation for this class was generated from the following file:

- OgrePose.h